curl --request POST \
--url https://iam.basaltic.sh/v1/oidc-providers \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"name": "github",
"issuer": "https://token.actions.githubusercontent.com",
"audiences": [
"basaltic-iam-sts"
],
"description": "<string>",
"tags": {}
}
'import requests
url = "https://iam.basaltic.sh/v1/oidc-providers"
payload = {
"name": "github",
"issuer": "https://token.actions.githubusercontent.com",
"audiences": ["basaltic-iam-sts"],
"description": "<string>",
"tags": {}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
name: 'github',
issuer: 'https://token.actions.githubusercontent.com',
audiences: ['basaltic-iam-sts'],
description: '<string>',
tags: {}
})
};
fetch('https://iam.basaltic.sh/v1/oidc-providers', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://iam.basaltic.sh/v1/oidc-providers",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'name' => 'github',
'issuer' => 'https://token.actions.githubusercontent.com',
'audiences' => [
'basaltic-iam-sts'
],
'description' => '<string>',
'tags' => [
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://iam.basaltic.sh/v1/oidc-providers"
payload := strings.NewReader("{\n \"name\": \"github\",\n \"issuer\": \"https://token.actions.githubusercontent.com\",\n \"audiences\": [\n \"basaltic-iam-sts\"\n ],\n \"description\": \"<string>\",\n \"tags\": {}\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://iam.basaltic.sh/v1/oidc-providers")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"name\": \"github\",\n \"issuer\": \"https://token.actions.githubusercontent.com\",\n \"audiences\": [\n \"basaltic-iam-sts\"\n ],\n \"description\": \"<string>\",\n \"tags\": {}\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://iam.basaltic.sh/v1/oidc-providers")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"name\": \"github\",\n \"issuer\": \"https://token.actions.githubusercontent.com\",\n \"audiences\": [\n \"basaltic-iam-sts\"\n ],\n \"description\": \"<string>\",\n \"tags\": {}\n}"
response = http.request(request)
puts response.read_body{
"oidc_provider": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"crn": "crn:iam::production:oidc-provider/github",
"name": "github",
"issuer": "https://token.actions.githubusercontent.com",
"audiences": [
"basaltic-iam-sts"
],
"is_system": false,
"tags": {},
"created_at": "2023-11-07T05:31:56Z",
"updated_at": "2023-11-07T05:31:56Z",
"description": "<string>"
}
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "Authentication required",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "ACCESS_DENIED",
"message": "You don't have permission to perform this action",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "NOT_FOUND",
"message": "Resource not found",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "CONFLICT",
"message": "Resource with this name already exists",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "INTERNAL_ERROR",
"message": "An internal error occurred",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}Crear un proveedor OIDC
Registre un emisor OIDC HTTPS y las audiencias permitidas en la cuenta seleccionada. El emisor debe publicar metadatos de descubrimiento y claves públicas de firma. Los roles deben confiar explícitamente en el proveedor y restringir el sujeto; el registro por sí solo no concede acceso.
curl --request POST \
--url https://iam.basaltic.sh/v1/oidc-providers \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"name": "github",
"issuer": "https://token.actions.githubusercontent.com",
"audiences": [
"basaltic-iam-sts"
],
"description": "<string>",
"tags": {}
}
'import requests
url = "https://iam.basaltic.sh/v1/oidc-providers"
payload = {
"name": "github",
"issuer": "https://token.actions.githubusercontent.com",
"audiences": ["basaltic-iam-sts"],
"description": "<string>",
"tags": {}
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
name: 'github',
issuer: 'https://token.actions.githubusercontent.com',
audiences: ['basaltic-iam-sts'],
description: '<string>',
tags: {}
})
};
fetch('https://iam.basaltic.sh/v1/oidc-providers', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://iam.basaltic.sh/v1/oidc-providers",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'name' => 'github',
'issuer' => 'https://token.actions.githubusercontent.com',
'audiences' => [
'basaltic-iam-sts'
],
'description' => '<string>',
'tags' => [
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://iam.basaltic.sh/v1/oidc-providers"
payload := strings.NewReader("{\n \"name\": \"github\",\n \"issuer\": \"https://token.actions.githubusercontent.com\",\n \"audiences\": [\n \"basaltic-iam-sts\"\n ],\n \"description\": \"<string>\",\n \"tags\": {}\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://iam.basaltic.sh/v1/oidc-providers")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"name\": \"github\",\n \"issuer\": \"https://token.actions.githubusercontent.com\",\n \"audiences\": [\n \"basaltic-iam-sts\"\n ],\n \"description\": \"<string>\",\n \"tags\": {}\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://iam.basaltic.sh/v1/oidc-providers")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"name\": \"github\",\n \"issuer\": \"https://token.actions.githubusercontent.com\",\n \"audiences\": [\n \"basaltic-iam-sts\"\n ],\n \"description\": \"<string>\",\n \"tags\": {}\n}"
response = http.request(request)
puts response.read_body{
"oidc_provider": {
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"crn": "crn:iam::production:oidc-provider/github",
"name": "github",
"issuer": "https://token.actions.githubusercontent.com",
"audiences": [
"basaltic-iam-sts"
],
"is_system": false,
"tags": {},
"created_at": "2023-11-07T05:31:56Z",
"updated_at": "2023-11-07T05:31:56Z",
"description": "<string>"
}
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "Authentication required",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "ACCESS_DENIED",
"message": "You don't have permission to perform this action",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "NOT_FOUND",
"message": "Resource not found",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "CONFLICT",
"message": "Resource with this name already exists",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "INTERNAL_ERROR",
"message": "An internal error occurred",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}iam:CreateOIDCProvider. Consulte permisos de IAM para obtener la lista completa, lo que cubre cada una y un ejemplo de directiva.Autorizaciones
Un token bearer de OAuth 2.0, enviado como Authorization: Bearer <token>. Esta es la forma recomendada de autenticación.
Obtén el token intercambiando el par de claves de acceso de una cuenta de servicio en POST /v1/oauth/token con grant_type=client_credentials. Es el flujo estándar de credenciales de cliente; las bibliotecas compatibles con OAuth pueden obtener y renovar el token por ti.
curl -s -u "$KEY_ID:$SECRET" -d grant_type=client_credentials \ https://iam.basaltic.sh/v1/oauth/token
Los tokens duran una hora por defecto. El mismo par de claves de acceso también sirve como credencial AWS SigV4 para el endpoint de objetos compatible con S3, que solo acepta ese método de autenticación.
Cuerpo
"github"
URL HTTPS inmutable del emisor. Los proveedores de clientes requieren endpoints públicos de descubrimiento y JWKS.
"https://token.actions.githubusercontent.com"
1 - 100 elements1 - 255["basaltic-iam-sts"]
Show child attributes
Show child attributes
Respuesta
Crear un proveedor OIDC
Show child attributes
Show child attributes

